import peasy.*;
import controlP5.*;

PeasyCam cam;
ControlP5 cp5;

Table table;
int rowNums;
ArrayList<HP> hps = new ArrayList <HP>();

//Menu
String[] title={"Harry Potter and the Sorcerer's Stone",
"Harry Potter and the Chamber of Secrets",
"Harry Potter and the Prisoner of Azkaban", 
"Harry Potter and the Goblet of Fire",
"Harry Potter and the Order of the Phoenix",
"Harry Potter and the Half-Blood Prince",
"Harry Potter and the Deathly Hallows",
"The Tales of Beedle the Bard",
"Harry Potter and the Cursed Child",
"Fantastic Beasts and Where to Find Them",
"Fantastic Beasts: The Crimes of Grindelwald",
"Quidditch Through the Ages"
};

boolean HP1Select = true;
boolean HP2Select = true;
boolean HP3Select = true;
boolean HP4Select = true;
boolean HP5Select = true;
boolean HP6Select = true;
boolean HP7Select = true;
boolean TBBSelect = true;
boolean CchildSelect = true;
boolean FBWTFSelect = true;
boolean FBCGSelect = true;
boolean QuidSelect = true;
boolean displayMenu = true;

//color
color HP1Color = #ffb3ba;
color HP2Color = #ffdfba;
color HP3Color = #ffffba;
color HP4Color = #baffc9;
color HP5Color = #e1f7d5;
color HP6Color = #bae1ff;
color HP7Color = #f1cbff;
color TBBColor = #bf40bf;
color CchildColor = #0392cf;
color FBWTFColor = #7bc043;
color FBCGColor = #f37736;
color QuidColor = #ff3131; 

//numbers
float radius = 100;
float incline = .4;
float scale = 10;
float helixSpace = 8;

int buttonWidth = 220;
int buttonHeight =25;
int buttonSpace = 30;


//SETUP
void setup(){
  size(1500,1000, P3D);
  cam = new PeasyCam(this, 200);
  
  //input data
  table = loadTable("Harrypotter.csv", "header");
  println(table.getRow(0));
  rowNums = table.getRowCount();
  for (int i=0; i<rowNums; i++){
    String date = table.getString(i,0);
    float HP1 = log(table.getInt(i, 1)+1);
    float HP2 = log(table.getInt(i, 2)+1);
    float HP3 = log(table.getInt(i, 3)+1);
    float HP4 = log(table.getInt(i, 4)+1);
    float HP5 = log(table.getInt(i, 5)+1);
    float HP6 = log(table.getInt(i, 6)+1);
    float HP7 = log(table.getInt(i, 7)+1);
    float TBB = log(table.getInt(i, 8)+1);
    float Cchild = log(table.getInt(i, 9)+1);
    float FBWTF = log(table.getInt(i, 10)+1);
    float FBCG = log(table.getInt(i, 11)+1);
    float Quid = log(table.getInt(i, 12)+1);
    hps.add(new HP(date, HP1, HP2, HP3, HP4, HP5, HP6, HP7, TBB, Cchild, FBWTF, FBCG, Quid));
  }
  
  
  //Menu control
  cp5 = new ControlP5(this);
  PFont font = createFont("Arial",10);
  textFont(font);
  for (int i = 0; i<12;i++){
    cp5.addButton(title[i])
    .setPosition(50,630+i*buttonSpace)
    .setSize(buttonWidth,buttonHeight)
    .setColorBackground(color(50))
    .setColorForeground(color(167))
    .setValue(0)
    .setId(i);
    cp5.getController(title[i]).getCaptionLabel().toUpperCase(false).setFont(font);
  }
  
  cp5.setAutoDraw(false);
}


void draw(){
  background(50);
  noFill();
 
  //helix outline
  //beginShape();
  //stroke(50);
  //for (int i = -1; i < rowNums; i++){
  //  curveVertex((radius+scale)*cos(i*2*PI/365), (radius+scale)*sin(i*2*PI/365),(-rowNums/2 +i)*incline);
  //}
  //endShape();
  
    
  //display data
  for (int i=0; i<rowNums-1; i++){
    pushMatrix();
    translate(0,0,(-rowNums/2 +i)*incline);
    rotateZ(i*2*PI/365);
    rotateX(0.1);
    translate(radius,0,0);
    
    HP thehp = hps.get(i);
    float HP1size = map(thehp.HP1,0,log(1000),0,455);
    float HP2size = map(thehp.HP2,0,log(1000),0,455);
    float HP3size = map(thehp.HP3,0,log(1000),0,455);
    float HP4size = map(thehp.HP4,0,log(1000),0,455);
    float HP5size = map(thehp.HP5,0,log(1000),0,455);
    float HP6size = map(thehp.HP6,0,log(1000),0,455);
    float HP7size = map(thehp.HP7,0,log(1000),0,455);
    float TBBsize = map(thehp.TBB,0,log(1000),0,455);
    float Cchildsize = map(thehp.Cchild,0,log(1000),0,455);
    float FBWTFsize = map(thehp.FBWTF,0,log(1000),0,455);
    float FBCGsize = map(thehp.FBCG,0,log(1000),0,455);
    float Quidsize = map(thehp.Quid,0,log(1000),0,455);
    
    float x = (radius*0.01)*cos(i*2*PI/365);
    float y = (radius*0.01)*sin(i*2*PI/365);
    float z = (-rowNums/2 +i)*incline*0.01;
    float p_x = screenX(x, y, z);
    float p_y = screenY(x, y, z);
    float distanceObjectMouse = sq(p_x - mouseX) + sq(p_y-mouseY);
    
    PFont note = createFont("Arial",20);
    
    if (HP1Select == true){
      stroke(255,179,186,HP1size);
      strokeWeight(thehp.HP1);
      line(x,y,z,(x+thehp.HP1),(y+thehp.HP1),(z+thehp.HP1));
      if (distanceObjectMouse < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        //scale(0.1);
        //textAlign(RIGHT,CENTER);
        String str0 = "\t Title: "+title[0]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP1));
        //text(str0, 20, 0, 0);
        popMatrix();
        
        cam.beginHUD();
        text(str0,20,40);
        cam.endHUD();
        }      
    }
    
    if(HP2Select == true){
      pushMatrix();
      translate(0,radius/12,helixSpace);
      stroke(255,223,186,HP2size);
      strokeWeight(thehp.HP2);
      line(x,y,z,(x+thehp.HP2),(y+thehp.HP2),(z+thehp.HP2));
      float p_x2 = screenX(x, y, z);
      float p_y2 = screenY(x, y, z);
      float distanceObjectMouse2 = sq(p_x2 - mouseX) + sq(p_y2-mouseY);
      if (distanceObjectMouse2 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str1 = "\t Title: "+title[1]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP2));
        popMatrix();
        
        cam.beginHUD();
        text(str1,20,40);
        cam.endHUD();
      }
      popMatrix();
    }

    if(HP3Select == true){
      pushMatrix();
      translate(0,radius/6,2*helixSpace);
      stroke(255,255,186,HP3size);
      strokeWeight(thehp.HP3);
      line(x,y,z,(x+thehp.HP3),(y+thehp.HP2),(z+thehp.HP3));
      float p_x3 = screenX(x, y, z);
      float p_y3 = screenY(x, y, z);
      float distanceObjectMouse3 = sq(p_x3 - mouseX) + sq(p_y3-mouseY);
      if (distanceObjectMouse3 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str2 = "\t Title: "+title[2]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP3));
        popMatrix();

        cam.beginHUD();
        text(str2,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(HP4Select == true){
      pushMatrix();
      translate(0,radius/4,3*helixSpace);
      stroke(186,255,201,HP4size);
      strokeWeight(thehp.HP4);
      line(x,y,z,(x+thehp.HP4),(y+thehp.HP4),(z+thehp.HP4));
      float p_x4 = screenX(x, y, z);
      float p_y4 = screenY(x, y, z);
      float distanceObjectMouse4 = sq(p_x4 - mouseX) + sq(p_y4-mouseY);
      if (distanceObjectMouse4 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str3 = "\t Title: "+title[3]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP4));
        popMatrix();
        
        cam.beginHUD();
        text(str3,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(HP5Select == true){
      pushMatrix();
      translate(0,radius/3,4*helixSpace);
      stroke(225,247,213,HP5size);
      strokeWeight(thehp.HP5);
      line(x,y,z,(x+thehp.HP5),(y+thehp.HP5),(z+thehp.HP5));
      float p_x5 = screenX(x, y, z);
      float p_y5 = screenY(x, y, z);
      float distanceObjectMouse5 = sq(p_x5 - mouseX) + sq(p_y5-mouseY);
      if (distanceObjectMouse5 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str4 = "\t Title: "+title[4]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP5));
        popMatrix();
        
        cam.beginHUD();
        text(str4,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(HP6Select == true){
      pushMatrix();
      translate(0,5*radius/12,5*helixSpace);
      stroke(186,225,255,HP6size);
      strokeWeight(thehp.HP6);
      line(x,y,z,(x+thehp.HP6),(y+thehp.HP6),(z+thehp.HP6));
      float p_x6 = screenX(x, y, z);
      float p_y6 = screenY(x, y, z);
      float distanceObjectMouse6 = sq(p_x6 - mouseX) + sq(p_y6-mouseY);
      if (distanceObjectMouse6 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str5 = "\t Title: "+title[5]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP6));
        popMatrix();
        
        cam.beginHUD();
        text(str5,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(HP7Select == true){
      pushMatrix();
      translate(0,radius/2,6*helixSpace);
      stroke(241,203,255,HP7size);
      strokeWeight(thehp.HP7);
      line(x,y,z,(x+thehp.HP7),(y+thehp.HP7),(z+thehp.HP7));
      float p_x7 = screenX(x, y, z);
      float p_y7 = screenY(x, y, z);
      float distanceObjectMouse7 = sq(p_x7 - mouseX) + sq(p_y7-mouseY);
      if (distanceObjectMouse7 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str6 = "\t Title: "+title[6]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.HP7));
        popMatrix();
        
        cam.beginHUD();
        text(str6,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(TBBSelect == true){
      pushMatrix();
      translate(0,7*radius/12,7*helixSpace);
      stroke(191,64,191,TBBsize);
      strokeWeight(thehp.TBB);
      line(x,y,z,(x+thehp.TBB),(y+thehp.TBB),(z+thehp.TBB));
      float p_x8 = screenX(x, y, z);
      float p_y8 = screenY(x, y, z);
      float distanceObjectMouse8 = sq(p_x8 - mouseX) + sq(p_y8-mouseY);
      if (distanceObjectMouse8 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str7 = "\t Title: "+title[7]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.TBB));
        popMatrix();
        
        cam.beginHUD();
        text(str7,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(CchildSelect == true){
      pushMatrix();
      translate(0,2*radius/3,8*helixSpace);
      stroke(3,146,207, Cchildsize);
      strokeWeight(thehp.Cchild);
      line(x,y,z,(x+thehp.Cchild),(y+thehp.Cchild),(z+thehp.Cchild));
      float p_x9 = screenX(x, y, z);
      float p_y9 = screenY(x, y, z);
      float distanceObjectMouse9 = sq(p_x9 - mouseX) + sq(p_y9-mouseY);
      if (distanceObjectMouse9 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str8 = "\t Title: "+title[8]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.Cchild));
        popMatrix();
        
        cam.beginHUD();
        text(str8,20,40);
        cam.endHUD();
      }
      popMatrix();
    }

    if(FBWTFSelect == true){
      pushMatrix();
      translate(0,3*radius/4,9*helixSpace);
      stroke(123,192,67,FBWTFsize);
      strokeWeight(thehp.FBWTF);
      line(x,y,z,(x+thehp.FBWTF),(y+thehp.FBWTF),(z+thehp.FBWTF));
      float p_x10 = screenX(x, y, z);
      float p_y10 = screenY(x, y, z);
      float distanceObjectMouse10 = sq(p_x10 - mouseX) + sq(p_y10-mouseY);
      if (distanceObjectMouse10 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str9 = "\t Title: "+title[9]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.FBWTF));
        popMatrix();
        
        cam.beginHUD();
        text(str9,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(FBCGSelect == true){
      pushMatrix();
      translate(0,5*radius/6,10*helixSpace);
      stroke(243,119,54,FBCGsize);
      strokeWeight(thehp.FBCG);
      line(x,y,z,(x+thehp.FBCG),(y+thehp.FBCG),(z+thehp.FBCG));
      float p_x11 = screenX(x, y, z);
      float p_y11 = screenY(x, y, z);
      float distanceObjectMouse11 = sq(p_x11 - mouseX) + sq(p_y11-mouseY);
      if (distanceObjectMouse11 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str10 = "\t Title: "+title[10]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.FBCG));
        popMatrix();
        
        cam.beginHUD();
        text(str10,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
    if(QuidSelect == true){
      pushMatrix();
      translate(0,11*radius/12,11*helixSpace);
      stroke(255,49,49,Quidsize);
      strokeWeight(thehp.Quid);
      line(x,y,z,(x+thehp.Quid),(y+thehp.Quid),(z+thehp.Quid));
      float p_x12 = screenX(x, y, z);
      float p_y12 = screenY(x, y, z);
      float distanceObjectMouse12 = sq(p_x12 - mouseX) + sq(p_y12-mouseY);
      if (distanceObjectMouse12 < 20) {
        pushMatrix();
        translate(x, y, z);
        fill(255);
        textFont(note);
        String str11 = "\t Title: "+title[11]+"\n Date: "+thehp.date+"\n Checkout number: "+Math.round(Math.pow(Math.E, thehp.Quid));
        popMatrix();
        
        cam.beginHUD();
        text(str11,20,40);
        cam.endHUD();
      }
      popMatrix();
    }
    
      popMatrix();
    }
  gui();
}


void controlEvent(ControlEvent theEvent){
  int id = theEvent.getController().getId();
  println(id);
  if(id==0){HP1Select =!HP1Select;}
  else if(id==1){HP2Select=!HP2Select;}
  else if(id==2){HP3Select=!HP3Select;}
  else if(id==3){HP4Select=!HP4Select;}
  else if(id==4){HP5Select=!HP5Select;}
  else if(id==5){HP6Select=!HP6Select;}
  else if(id==6){HP7Select=!HP7Select;}
  else if(id==7){TBBSelect=!TBBSelect;}
  else if(id==8){CchildSelect=!CchildSelect;}
  else if(id==9){FBWTFSelect=!FBWTFSelect;}
  else if(id==10){FBCGSelect=!FBCGSelect;}
  else if(id==11){QuidSelect=!QuidSelect;}

}


void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();

  if(displayMenu == true){
   
    //genre menu buttons
    if (HP1Select == true){
      fill(HP1Color);
      stroke(HP1Color);
      rect(50-buttonHeight, 630,buttonHeight,buttonHeight);
    }
    if (HP2Select== true){
      fill(HP2Color);
      stroke(HP2Color);
      rect(50- buttonHeight, 630+buttonSpace,buttonHeight,buttonHeight);
    }
    if (HP3Select == true){
      fill(HP3Color);
      stroke(HP3Color);
      rect(50- buttonHeight, 630+2*buttonSpace, buttonHeight,buttonHeight);
    }
    if (HP4Select == true){
      fill(HP4Color);
      stroke(HP4Color);
      rect(50- buttonHeight, 630+3*buttonSpace,buttonHeight,buttonHeight);
    }
    if (HP5Select == true){
      fill(HP5Color);
      stroke(HP5Color);
      rect(50- buttonHeight, 630+4*buttonSpace,buttonHeight,buttonHeight);
    }
    if (HP6Select == true){
      fill(HP6Color);
      stroke(HP6Color);
      rect(50- buttonHeight, 630+5*buttonSpace,buttonHeight,buttonHeight);
    }
    if (HP7Select == true){
      fill(HP7Color);
      stroke(HP7Color);
      rect(50- buttonHeight, 630+6*buttonSpace,buttonHeight,buttonHeight);
    }
    if (TBBSelect == true){
      fill(TBBColor);
      stroke(TBBColor);
      rect(50- buttonHeight, 630+7*buttonSpace,buttonHeight,buttonHeight);
    }   
    if (CchildSelect == true){
      fill(CchildColor);
      stroke(CchildColor);
      rect(50- buttonHeight, 630+8*buttonSpace,buttonHeight,buttonHeight);
    }
    if (FBWTFSelect == true){
      fill(FBWTFColor);
      stroke(FBWTFColor);
      rect(50- buttonHeight, 630+9*buttonSpace,buttonHeight,buttonHeight);
    }
    if (FBCGSelect == true){
      fill(FBCGColor);
      stroke(FBCGColor);
      rect(50- buttonHeight, 630+10*buttonSpace,buttonHeight,buttonHeight);
    }
    if (QuidSelect == true){
      fill(QuidColor);
      stroke(QuidColor);
      rect(50- buttonHeight, 630+11*buttonSpace,buttonHeight,buttonHeight);
    }
     
    cp5.draw();}
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
  }
